All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
7 mr - a Multiple Repository management tool
11 B<mr> [options] checkout
13 B<mr> [options] update
15 B<mr> [options] status
17 B<mr> [options] commit [-m "message"]
23 B<mr> [options] register [repository]
25 B<mr> [options] config section [parameter=[value] ...]
27 B<mr> [options] action [params ...]
31 B<mr> is a Multiple Repository management tool. It
32 can checkout, update, or perform other actions on
33 a set of repositories as if they were one combined respository. It
34 supports any combination of subversion, git, cvs, and bzr repositories,
35 and support for other revision control systems can easily be added.
37 B<mr> cds into and operates on all registered repositories at or below your
38 working directory. Or, if you are in a subdirectory of a repository that
39 contains no other registered repositories, it will stay in that directory,
40 and work on only that repository,
42 These predefined commands should be fairly familiar to users of any revision
47 =item checkout (or co)
49 Checks out any repositories that are not already checked out.
53 Updates each repository from its configured remote repository.
55 If a repository isn't checked out yet, it will first check it out.
59 Displays a status report for each repository, showing what
60 uncommitted changes are present in the repository.
64 Commits changes to each repository. (By default, changes are pushed to the
65 remote repository too, when using distributed systems like git.)
67 The optional -m parameter allows specifying a commit message.
71 Show a diff of uncommitted changes.
79 These commands are also available:
85 List the repositories that mr will act on.
89 Register an existing repository in the mrconfig file. By default, the
90 repository in the current directory is registered, or you can specify a
91 directory to register.
93 By default it registers it to the ~/.mrconfig file. To make it write to a
94 different file, use the -c option.
98 Adds, modifies, removes, or prints a value from the mrconfig file. The next
99 parameter is the name of the section the value is in. To add or modify
100 values, use one or more instances of "parameter=value". Use "parameter=" to
101 remove a parameter. Use just "parameter" to get the value of a parameter.
103 For example, to add (or edit) a repository in src/foo:
105 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
107 To show the command that mr uses to update the repository in src/foo:
109 mr config src/foo update
117 Actions can be abbreviated to any unambiguous subsctring, so
118 "mr st" is equivilant to "mr status", and "mr up" is equivilant to "mr
121 Additional parameters can be passed to most commands, and are passed on
122 unchanged to the underlying revision control system. This is mostly useful
123 if the repositories mr will act on all use the same revision control
132 Specifies the topmost directory that B<mr> should work in. The default is
133 the current working directory.
137 Use the specified mrconfig file, instead of looking for one in your home
146 Expand the statistics line displayed at the end to include information
147 about exactly which repositories failed and were skipped, if any.
151 Just operate on the repository for the current directory, do not
152 recurse into deeper repositories.
158 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
159 file in your home directory, and this can in turn chain load .mrconfig files
162 Here is an example .mrconfig file:
165 checkout = svn co svn://svn.example.com/src/trunk src
169 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
171 git checkout -b mybranch origin/master
173 The .mrconfig file uses a variant of the INI file format. Lines starting with
174 "#" are comments. Values can be continued to the following line by
175 indenting the line with whitespace.
177 The "DEFAULT" section allows setting default values for the sections that
180 The "ALIAS" section allows adding aliases for actions. Each parameter
181 is an alias, and its value is the action to use.
183 All other sections add repositories. The section header specifies the
184 directory where the repository is located. This is relative to the directory
185 that contains the mrconfig file, but you can also choose to use absolute
188 Within a section, each parameter defines a shell command to run to handle a
189 given action. mr contains default handlers for the "update", "status", and
190 "commit" actions, so normally you only need to specify what to do for
193 Note that these shell commands are run in a "set -e" shell
194 environment, where any additional parameters you pass are available in
195 "$@". The "checkout" command is run in the parent of the repository
196 directory, since the repository isn't checked out yet. All other commands
197 are run inside the repository, though not necessarily at the top of it.
198 The "MR_REPO" environment variable is set to the path to the top of the
199 repository, and "MR_CONFIG" is set to the topmost .mrconfig file used.
201 A few parameters have special meanings:
207 If the "skip" parameter is set and its command returns true, then B<mr>
208 will skip acting on that repository. The command is passed the action
211 Here are two examples. The first skips the repo unless
212 mr is run by joey. The second uses the hours_since function
213 (included in mr's built-in library) to skip updating the repo unless it's
214 been at least 12 hours since the last update.
216 skip = test $(whoami) != joey
217 skip = [ "$1" = update ] && [ $(hours_since "$1") -lt 12 ]
221 If the "chain" parameter is set and its command returns true, then B<mr>
222 will try to load a .mrconfig file from the root of the repository. (You
223 should avoid chaining from repositories with untrusted committers.)
227 If the "deleted" parameter is set and its command returns true, then
228 B<mr> will treat the repository as deleted. It won't ever actually delete
229 the repository, but it will warn if it sees the repository's directory.
230 This is useful when one mrconfig file is shared amoung multiple machines,
231 to keep track of and remember to delete old repositories.
235 The "lib" parameter can specify some shell code that will be run before each
236 command, this can be a useful way to define shell functions for other commands
243 Copyright 2007 Joey Hess <joey@kitenet.net>
245 Licensed under the GNU GPL version 2 or higher.
247 http://kitenet.net/~joey/code/mr/
256 use Cwd qw(getcwd abs_path);
259 print STDERR "mr: interrupted\n";
263 $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
264 my $directory=getcwd();
272 Getopt::Long::Configure("no_permute");
273 my $result=GetOptions(
274 "d|directory=s" => sub { $directory=abs_path($_[1]) },
275 "c|config=s" => sub { $ENV{MR_CONFIG}=abs_path($_[1]) },
276 "v|verbose" => \$verbose,
277 "s|stats" => \$stats,
278 "n|no-recurse" => \$no_recurse,
280 if (! $result || @ARGV < 1) {
281 die("Usage: mr [-d directory] action [params ...]\n".
282 "(Use mr help for man page.)\n");
287 loadconfig($ENV{MR_CONFIG});
289 #print Dumper(\%config);
292 use FindBin qw($Bin $Script);
293 $ENV{MR_PATH}=$Bin."/".$Script;
296 # alias expansion and command stemming
297 my $action=shift @ARGV;
298 if (exists $alias{$action}) {
299 $action=$alias{$action};
301 if (! exists $knownactions{$action}) {
302 my @matches = grep { /^\Q$action\E/ }
303 keys %knownactions, keys %alias;
307 elsif (@matches == 0) {
308 die "mr: unknown action \"$action\" (known actions: ".
309 join(", ", sort keys %knownactions).")\n";
312 die "mr: ambiguous action \"$action\" (matches: ".
313 join(", ", @matches).")\n";
317 if ($action eq 'help') {
318 exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
320 elsif ($action eq 'config') {
322 die "mr config: not enough parameters\n";
325 if ($section=~/^\//) {
326 # try to convert to a path relative to the config file
327 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
328 if ($section=~/^\Q$dir\E(.*)/) {
334 if (/^([^=]+)=(.*)$/) {
335 $changefields{$1}=$2;
339 foreach my $topdir (sort keys %config) {
340 if (exists $config{$topdir}{$section} &&
341 exists $config{$topdir}{$section}{$_}) {
342 print $config{$topdir}{$section}{$_}."\n";
347 die "mr $action: $section $_ not set\n";
351 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
354 elsif ($action eq 'register') {
355 my $command="set -e; ".$config{''}{DEFAULT}{lib}."\n".
356 "my_action(){ $config{''}{DEFAULT}{$action}\n }; my_action ".
357 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
358 print STDERR "mr $action: running >>$command<<\n" if $verbose;
359 exec($command) || die "exec: $!";
362 # work out what repos to act on
365 foreach my $topdir (sort keys %config) {
366 foreach my $subdir (sort keys %{$config{$topdir}}) {
367 next if $subdir eq 'DEFAULT';
368 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
370 $dir.="/" unless $dir=~/\/$/;
371 $d.="/" unless $d=~/\/$/;
372 next if $no_recurse && $d ne $dir;
373 next if $dir ne $d && $dir !~ /^\Q$d\E/;
374 push @repos, [$dir, $topdir, $subdir];
378 # fallback to find a leaf repo
379 LEAF: foreach my $topdir (reverse sort keys %config) {
380 foreach my $subdir (reverse sort keys %{$config{$topdir}}) {
381 next if $subdir eq 'DEFAULT';
382 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
384 $dir.="/" unless $dir=~/\/$/;
385 $d.="/" unless $d=~/\/$/;
386 if ($d=~/^\Q$dir\E/) {
387 push @repos, [$dir, $topdir, $subdir];
395 my (@failed, @ok, @skipped);
396 foreach my $repo (@repos) {
397 action($action, @$repo);
401 my ($action, $dir, $topdir, $subdir) = @_;
403 my $lib= exists $config{$topdir}{$subdir}{lib} ?
404 $config{$topdir}{$subdir}{lib}."\n" : "";
406 if (exists $config{$topdir}{$subdir}{deleted}) {
407 my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
408 print "mr $action: running deleted test >>$test<<\n" if $verbose;
409 my $ret=system($test);
411 if (($? & 127) == 2) {
412 print STDERR "mr $action: interrupted\n";
416 print STDERR "mr $action: deleted test received signal ".($? & 127)."\n";
419 if ($ret >> 8 == 0) {
421 print STDERR "mr error: $dir should be deleted yet still exists\n\n";
426 print "mr $action: $dir skipped (as deleted) per config file\n" if $verbose;
433 if ($action eq 'checkout') {
435 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
440 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
443 print "mr $action: creating parent directory $dir\n" if $verbose;
444 my $ret=system("mkdir", "-p", $dir);
447 elsif ($action eq 'update') {
449 return action("checkout", $dir, $topdir, $subdir);
455 if (exists $config{$topdir}{$subdir}{skip}) {
456 my $test="set -e;".$lib.
457 "my_action(){ $config{$topdir}{$subdir}{skip}\n }; my_action '$action'";
458 print "mr $action: running skip test >>$test<<\n" if $verbose;
459 my $ret=system($test);
461 if (($? & 127) == 2) {
462 print STDERR "mr $action: interrupted\n";
466 print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
470 if ($ret >> 8 == 0) {
471 print "mr $action: $dir skipped per config file\n" if $verbose;
477 if (! $nochdir && ! chdir($dir)) {
478 print STDERR "mr $action: failed to chdir to $dir: $!\n";
481 elsif (! exists $config{$topdir}{$subdir}{$action}) {
482 print STDERR "mr $action: no defined $action command for $topdir$subdir, skipping\n";
487 print "mr $action: $topdir$subdir\n";
490 print "mr $action: $topdir$subdir (in subdir $directory)\n";
492 my $command="set -e; ".$lib.
493 "my_action(){ $config{$topdir}{$subdir}{$action}\n }; my_action ".
494 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
495 print STDERR "mr $action: running >>$command<<\n" if $verbose;
496 my $ret=system($command);
498 if (($? & 127) == 2) {
499 print STDERR "mr $action: interrupted\n";
503 print STDERR "mr $action: received signal ".($? & 127)."\n";
505 print STDERR "mr $action: failed ($ret)\n" if $verbose;
507 if ($ret >> 8 != 0) {
508 print STDERR "mr $action: command failed\n";
511 print STDERR "mr $action: command died ($ret)\n";
515 if ($action eq 'checkout' && ! -d $dir) {
516 print STDERR "mr $action: $dir missing after checkout\n";;
533 return "$count ".($count > 1 ? $plural : $singular);
537 if (! @ok && ! @failed && ! @skipped) {
538 die "mr $action: no repositories found to work on\n";
540 print "mr $action: finished (".join("; ",
541 showstat($#ok+1, "ok", "ok"),
542 showstat($#failed+1, "failed", "failed"),
543 showstat($#skipped+1, "skipped", "skipped"),
547 print "mr $action: (skipped: ".join(" ", @skipped).")\n";
550 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
556 elsif (! @ok && @skipped) {
562 sub loadconfig { #{{{
569 if (ref $f eq 'GLOB') {
578 my $absf=abs_path($f);
579 if ($loaded{$absf}) {
584 ($dir)=$f=~/^(.*\/)[^\/]+$/;
585 if (! defined $dir) {
588 $dir=abs_path($dir)."/";
590 # copy in defaults from first parent
592 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
593 if ($parent eq '/') {
596 if (exists $config{$parent} &&
597 exists $config{$parent}{DEFAULT}) {
598 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
603 print "mr: loading config $f\n" if $verbose;
604 open($in, "<", $f) || die "mr: open $f: $!\n";
615 next if /^\s*\#/ || /^\s*$/;
616 if (/^\[([^\]]*)\]\s*$/) {
619 elsif (/^(\w+)\s*=\s*(.*)/) {
624 while (@lines && $lines[0]=~/^\s(.+)/) {
631 if (! defined $section) {
632 die "$f line $.: parameter ($parameter) not in section\n";
634 if ($section ne 'ALIAS' &&
635 ! exists $config{$dir}{$section} &&
636 exists $config{$dir}{DEFAULT}) {
638 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
640 if ($section eq 'ALIAS') {
641 $alias{$parameter}=$value;
643 elsif ($parameter eq 'lib') {
644 $config{$dir}{$section}{lib}.=$value."\n";
647 $config{$dir}{$section}{$parameter}=$value;
648 $knownactions{$parameter}=1;
649 if ($parameter eq 'chain' &&
650 length $dir && $section ne "DEFAULT" &&
651 -e $dir.$section."/.mrconfig") {
652 my $ret=system($value);
654 if (($? & 127) == 2) {
655 print STDERR "mr $action: chain test interrupted\n";
659 print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
663 push @toload, $dir.$section."/.mrconfig";
669 die "$f line $line: parse error\n";
678 sub modifyconfig { #{{{
680 # the section to modify or add
681 my $targetsection=shift;
682 # fields to change in the section
683 # To remove a field, set its value to "".
690 open(my $in, "<", $f) || die "mr: open $f: $!\n";
695 my $formatfield=sub {
697 my @value=split(/\n/, shift);
699 return "$field = ".shift(@value)."\n".
700 join("", map { "\t$_\n" } @value);
704 while ($out[$#out] =~ /^\s*$/) {
705 unshift @blanks, pop @out;
707 foreach my $field (sort keys %changefields) {
708 if (length $changefields{$field}) {
709 push @out, "$field = $changefields{$field}\n";
710 delete $changefields{$field};
720 if (/^\s*\#/ || /^\s*$/) {
723 elsif (/^\[([^\]]*)\]\s*$/) {
724 if (defined $section &&
725 $section eq $targetsection) {
733 elsif (/^(\w+)\s*=\s(.*)/) {
738 while (@lines && $lines[0]=~/^\s(.+)/) {
744 if ($section eq $targetsection) {
745 if (exists $changefields{$parameter}) {
746 if (length $changefields{$parameter}) {
747 $value=$changefields{$parameter};
749 delete $changefields{$parameter};
753 push @out, $formatfield->($parameter, $value);
757 if (defined $section &&
758 $section eq $targetsection) {
761 elsif (%changefields) {
762 push @out, "\n[$targetsection]\n";
763 foreach my $field (sort keys %changefields) {
764 if (length $changefields{$field}) {
765 push @out, $formatfield->($field, $changefields{$field});
770 open(my $out, ">", $f) || die "mr: write $f: $!\n";
775 # Finally, some useful actions that mr knows about by default.
776 # These can be overridden in ~/.mrconfig.
791 for dir in .git .svn .bzr CVS; do
792 if [ -e "$MR_REPO/$dir" ]; then
793 flagfile="$MR_REPO/$dir/.mr_last$1"
797 if [ -z "$flagfile" ]; then
798 error "cannot determine flag filename"
800 perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile"
805 if [ -d "$MR_REPO"/.svn ]; then
807 elif [ -d "$MR_REPO"/.git ]; then
808 git pull origin master "$@"
809 elif [ -d "$MR_REPO"/.bzr ]; then
811 elif [ -d "$MR_REPO"/CVS ]; then
814 error "unknown repo type"
817 if [ -d "$MR_REPO"/.svn ]; then
819 elif [ -d "$MR_REPO"/.git ]; then
820 git status "$@" || true
821 elif [ -d "$MR_REPO"/.bzr ]; then
823 elif [ -d "$MR_REPO"/CVS ]; then
826 error "unknown repo type"
829 if [ -d "$MR_REPO"/.svn ]; then
831 elif [ -d "$MR_REPO"/.git ]; then
832 git commit -a "$@" && git push --all
833 elif [ -d "$MR_REPO"/.bzr ]; then
834 bzr commit "$@" && bzr push
835 elif [ -d "$MR_REPO"/CVS ]; then
838 error "unknown repo type"
841 if [ -d "$MR_REPO"/.svn ]; then
843 elif [ -d "$MR_REPO"/.git ]; then
845 elif [ -d "$MR_REPO"/.bzr ]; then
847 elif [ -d "$MR_REPO"/CVS ]; then
850 error "unknown repo type"
853 if [ -d "$MR_REPO"/.svn ]; then
855 elif [ -d "$MR_REPO"/.git ]; then
857 elif [ -d "$MR_REPO"/.bzr ]; then
859 elif [ -d "$MR_REPO"/CVS ]; then
862 error "unknown repo type"
868 basedir="$(basename $(pwd))"
870 url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
871 if [ -z "$url" ]; then
872 error "cannot determine svn url"
874 echo "Registering svn url: $url"
875 mr -c "$MR_CONFIG" config "$(pwd)" checkout="svn co $url $basedir"
876 elif [ -d .git ]; then
877 url=$(LANG=C git-config --get remote.origin.url)
878 if [ -z "$url" ]; then
879 error "cannot determine git url"
881 echo "Registering git url: $url"
882 mr -c "$MR_CONFIG" config "$(pwd)" checkout="git clone $url $basedir"
883 elif [ -d .bzr ]; then
884 url=$(cat .bzr/branch/parent)
885 if [ -z "$url" ]; then
886 error "cannot determine bzr url"
888 echo "Registering bzr url: $url"
889 mr -c "$MR_CONFIG" config "$(pwd)" checkout="bzr clone $url $basedir"
891 error "unable to register this repo type"
894 if [ ! -e "$MR_PATH" ]; then
895 error "cannot find program path"
897 (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
901 ed = echo "A horse is a horse, of course, of course.."
902 T = echo "I pity the fool."
903 right = echo "Not found."